/* Ǽưʬ ѡ5 */
/* 14ܿʬ 8:6*/
/* ccmg ǥѥ    */ 

#include <math.h>
#include <stdio.h>
#include <matrix.h>

#define N  14
#define U  (2*N+1)*(2*N+1)
#define P  (N+1)*(N+1)
#define T  2*N*N
#define SIZE 2*U+P

#define V 1.0 
#define nurho 1.0  /*     ͡ߦ     */

number_u(k,z)
int k,z[6];
{
  int r ;
  
  if(k % (2*N) < N) {
    r = k / N ;
    z[0] = 2*k + r ;
    z[1] = z[0] + 2*(2*N+1) ;
    z[2] = z[0] +  2 ;
    z[3] = z[0] + 2*N+2 ;
    z[4] = z[0] +  1 ;
    z[5] = z[0] + 2*N+1 ;
  }
  else {
    r = k / N - 1 ;
    z[0] = 2*k + r + 2*N+4 ; /* 24 ; */
    z[1] = z[0] - 2*(2*N+1) ;
    z[2] = z[0] -  2 ;
    z[3] = z[0] - (2*N+2) ;
    z[4] = z[0] -  1 ;
    z[5] = z[0] - (2*N+1) ;
  }    
}

number_v(k,z)
int k,z[6];
{
  int r;
  
  if(k % (2*N) < N) {
    r = k / N;
    z[0] = 2*k + r;
    z[1] = z[0]+ 2*(2*N+1);
    z[2] = z[0]+ 2*(2*N+1)+ 2;
    z[3] = z[1]+ 1;
    z[5] = z[0]+ 2*N+ 1;
    z[4] = z[5]+ 1;
    }
  else{
    z[0] = 2*k + r + 2*N+4 ; /* 24 ; */
    z[1] = z[0]- 2*(2*N+1);
    z[2] = z[1]- 2;
    z[3] = z[1]- 1;
    z[5] = z[0]- 2*N-1;
    z[4] = z[5]-1;
  }
}


cal2(M,x,y,bx,by)
int M;
vector x,y,bx,by;
{
  int    i,j,lo,cm;              /*  lough & complex*/
  double la,lb;
  
  cm= 2*N/7;
  lo= 3*N/14;
  la= 0.125/cm;                      /*0.125= 0.25/2 */
  lb= 0.125/lo;
  
  for(j=0; j<2*cm; j++){
    x[j]= j*la;
    y[j]= j*la;
  }

  for(j=0; j<= 2*lo; j++){
    x[2*cm+ j]= j*lb+ 0.25;
    y[2*cm+ j]= j*lb+ 0.25;
    bx[j]   = j*lb;
    by[j]   = j*lb;
  }
  for(j=1; j<= 2*cm; j++){
    bx[2*lo+ j]= j*la+ 0.25;
    by[2*lo+ j]= j*la+ 0.25;
  }

}

main(argc,argv) /*L.538*/
int argc;
char **argv;
{
  FILE *f;
  int i,j,k,N2,zu[6],zv[6];
  double cond,condp1,work[SIZE],u[SIZE];
  vector x,y,bx,by;

  x= new_vector(N);
  y= new_vector(N);
  bx= new_vector(N);
  by= new_vector(N);


  if((f = fopen(argv[1],"w")) == NULL){
    fprintf(stderr,"can't open %s \n",argv[1]);
    exit(1);
  }  

  fprintf(f, "%d %d",T,U);
  fprintf(f, "\n");

/*
  for(i=0;i<U;i++){
    fprintf(f, "%20.15lf  %20.15lf \n",cal_x(i),cal_y(i));
  }
*/

  cal2(N,x,y,bx,by);
  
  for(j=0; j< N; j++){
    for(i=0; i< N; i++)
      fprintf(f,"%20.15lf  %20.15lf \n", x[j], y[i]);
      for(i=0; i<= N; i++)
	fprintf(f,"%20.15lf  %20.15lf \n", x[j], 0.5+ by[i]);
  }

  for(j=0; j<= N; j++){
    for(i=0; i< N; i++)
      fprintf(f,"%20.15lf  %20.15lf \n", 0.5+ bx[j], y[i] );
    for(i=0; i<= N; i++)
      fprintf(f,"%20.15lf  %20.15lf \n", 0.5+ bx[j], 0.5+ by[i]);
  }
  fprintf(f,"\n");

  for(i=0;i<T;i++){
    number_u(i,zu);
    for(j=0;j<6;j++){
      fprintf(f," %4d ",zu[j]);
    }
    fprintf(f,"\n");
  }
  fprintf(f,"\n");

/*
  for(i=1; i<=N/2; i++){
    for(k=1; k<=N/2; k++){
      number_u(k,zu);
      for(j=0;j<6;j++)
	fprintf(f," %4d ",zu[j]);
      fprintf(f,"\n");
    }

    for(k=1; k<=N/2; k++){
      number_v(k,zv);
      for(j=0; j<6; j++)
	fprintf(f," %4d ",zv[j]);
           fprintf(f,"\n");
    }
  }
  for(i=1; i<=N/2; i++){
    for(k=1; k<=N/2; k++){
      number_v(k,zv);
      for(j=0;j<6;j++)
        fprintf(f," %4d ",zv[j]);
            fprintf(f,"\n");
    }
    for(k=1; k<=N/2; k++){
      number_u(k,zu);
      for(j=0; j<6; j++)
        fprintf(f," %4d ",zu[j]);
            fprintf(f,"\n");
    }

  
    fprintf(f,"\n");
  }
  fprintf(f,"\n");
*/

  k = 0;
  for(i=0;i<U;i++){
    fprintf(f,"%4d \n",k);
    if(i%(2*(2*N+1)) < (2*N+1) && (i%2)==0 ) j = 3;
    else j = 2;
    k += j;
  }
  fprintf(f,"\n");

  fprintf(f,"%4d \n",k);
  fprintf(f,"\n");

  fprintf(f,"0.05 1.0 \n");
  fprintf(f,"\n");

  fprintf(f,"%d 0\n",8*N);
  fprintf(f,"\n");

  for(k=1;k<2*N;k++){
    fprintf(f,"%4d %23.20lf %23.20lf \n",k,0.0,0.0);
  }

  for(k=0;k<=(2*N+1)*2*N;k+=(2*N+1)){
    fprintf(f,"%4d 0.0 0.0 \n",k);
  }

  for(k=(2*N);k<(2*N+1)*(2*N+1);k+=(2*N+1)){
    fprintf(f,"%4d %23.20lf %23.20lf \n",k,1.0 ,0.0);
  }

  for(k=(2*N+1)*2*N+1;k<(2*N+1)*(2*N+1)-1;k++){
    fprintf(f,"%4d %23.20lf %23.20lf \n",k,0.0 ,0.0);
  }

  fprintf(f,"\n");

  for(i=0;i<U;i++){
    fprintf(f,"0.0 0.0 \n");
  }
}






