/*
 * new_t-stokes2.c
 * ccmg ; compile
 */

#include <math.h>
#include <stdio.h>
#include <matrix.h>

#define L  20000
#define L2 500000

matrix new_matrix2(m, n)
int m, n;
{
    int i, j;
    matrix a;
    a = new_matrix(m, n);
    if (a != NULL) {
        for (i = 0; i < m; i++)
            for (j = 0; j < n; j++)
                a[i][j] = 0.0;
        return a;
    } else {
        fprintf(stderr, "new_matrix2: cannot allocate\n");
        exit(2);
    }
}

main(argc, argv)
int argc;
char **argv;
{
    FILE *f1, *f2, *f3;
    int i, j, k, time, skip, U, T, SIZE, M, N, D, ND;
    int **num;
    int min, max, width, MAX;
    int first_time = 1;
    double nu, rho;
    double tau, tht;
    vector a, x, y, u, new_u, bx, by, fx, fy, sx, sy, exforcx, exforcy, e;
    matrix o, moo, mxx, myy, hx, hy;
    ivector cum, b, ne, ip, ie;

    if (argc != 4) {
        fprintf(stderr, "usage: %s ͥǡ ΰǡ output\n", argv[0]);
        exit(0);
    }

/*
 * tau; ֤ι
 * tht;     
 * time; ֤β      
 * skip; skip٤output-data˽񤭹  
 */
#ifdef  USER_INPUT
    printf("tau & thata = ?");
    scanf("%lf %lf", &tau, &tht);
    printf("֤ο t:= t* tau");
    scanf("%d", &time);
    skip = 10;
#else
    tau = 0.01;
    tht = 0.0;
    time = 100;
    skip = 10;
#endif


/* input-data ɤ߹  */  

    if ((f2 = fopen(argv[2], "r")) == NULL) {
        fprintf(stderr, "Can't open %s", argv[2]);
        exit(1);
    }
    fscanf(f2, "%d %d", &T, &U);
    printf("T=%d, U=%d\n", T, U);

    x = new_vector(U);
    y = new_vector(U);
    for (i = 0; i < U; i++) {
        fscanf(f2, "%lf %lf", &x[i], &y[i]);
    }

    num = (int **) malloc(T * sizeof(void *));
    if (num == NULL)
        printf("ǤбѤΥ꡼­ޤ\n");
    for (i = 0; i < T; i++) {
        num[i] = (int *) malloc(sizeof(int) * 6);
        if (num[i] == NULL) {
            printf("ǤбѤΥ꡼­ޤ\n");
        }
    }
    for (i = 0; i < T; i++) {
        for (j = 0; j < 6; j++) {
            fscanf(f2, "%d", &num[i][j]);
        }
    }

    if ((cum = new_ivector(U)) == NULL) {
        fprintf(stderr, "ֹѤΥ꡼­ޤ \n");
        exit(1);
    }
    for (i = 0; i < U; i++)
        fscanf(f2, "%d", &cum[i]);
    fscanf(f2, "%d", &SIZE);


/*
 *  u;       Ρʱաˤή®ϥ٥ȥ
 *  new_u;   ̤Ρʺաˤή®ϥ٥ȥ
 *  exforcx; ϤNeumann B.C. xʬμ
 *  exforcy; ϤNeumann B.C. yʬμ
 */

    u = new_vector(SIZE);
    new_u = new_vector(SIZE);
    exforcx = new_vector(SIZE);
    exforcy = new_vector(SIZE);
    if ((o = new_matrix2(SIZE, SIZE)) == NULL) {
        fprintf(stderr, "cannot allocate matrix o[][]\n");
        exit(1);
    }
    for (i = 0; i < SIZE; i++) {
        u[i] = new_u[i] = exforcx[i] = exforcy[i] = 0.0;
        for (j = 0; j < SIZE; j++)
            o[i][j] = 0.0;
    }

    fscanf(f2, "%lf %lf", &nu, &rho);
    fscanf(f2, "%d %d", &D, &N);

    ND = N + D;

    if ((b = new_ivector(ND)) == NULL) {
        fprintf(stderr, "ֹѤΥ꡼­ޤ\n");
        exit(1);
    }
    bx = new_vector(ND);
    by = new_vector(ND);
    for (i = 0; i < ND; i++) {
        fscanf(f2, "%d %lf %lf", &b[i], &bx[i], &by[i]);
    }

    sx = new_vector(U);
    sy = new_vector(U);
    for (i = 0; i < U; i++) {
        sx[i] = sy[i] = 0.0;
    }
    if (N != 0) {
        for (i = D; i < ND; i++) {
            sx[b[i]] = bx[i];
            sy[b[i]] = by[i];
        }
    }
    fx = new_vector(U);
    fy = new_vector(U);
    for (i = 0; i < U; i++) {
        fscanf(f2, "%lf %lf", &fx[i], &fy[i]);
    }

    fclose(f2);

    /* ͤ */
    if ((f1 = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Can't open %s", argv[1]);
        exit(1);
    }
    printf("arg1 is clear\n");
    for (i = 0; i < SIZE; i++)
        fscanf(f1, "%lf", &u[i]);

    fclose(f1);

    printf("calculating....\n");

    /* 褤׻ */
    hx = new_matrix2(6, 3);
    hy = new_matrix2(6, 3);
    mxx = new_matrix2(6, 6);
    moo = new_matrix2(6, 6);
    myy = new_matrix2(6, 6);

    printf("matrix making...\n");
    make(T, SIZE, o, u, nu, rho, tau, tht, x, y, num, cum, fx, fy, sx, sy,
         exforcx, exforcy, moo, mxx, myy, hx, hy);

    printf(" matrix making is succesful\n");

    /* check the number of band */
    MAX = 0;
    for (i = 0; i < SIZE; i++) {
        min = i;
        for (k = 0; k <= i; k++)
            if (o[i][k] != 0.0) {
                min = k;
                break;
            }
        max = i;
        for (k = SIZE - 1; k >= i; k--)
            if (o[i][k] != 0.0) {
                max = k;
                break;
            }
        width = max - min;
        if (width > MAX)
            MAX = width;
    }
    printf("Х= %d\n", MAX);

    free_vector(x);
    free_vector(y);
    free_vector(fx);
    free_vector(fy);
    free_vector(sx);
    free_vector(sy);

    /* Ǥˤ̾Υե뤬ä硢ƤڤΤƤ롣 */
    f3 = fopen(argv[3], "w");
    fclose(f3);

    for (i = 0; i <= time; i++) {
        printf("%d-th time\n", i);

        printf(" umake...");
        umake(T, o, u, moo, mxx, myy, hx, hy, new_u, exforcx, exforcy,
              num, cum, nu, rho, tau, tht, SIZE);
        printf("done\n");

        printf(" bound...");
        bound(o, u, b, bx, by, N, D, cum, SIZE);
        printf("done\n");

#ifdef ORIGINAL
        printf(" etalu...");
        fflush(stdout);
        etalu(o, u, SIZE);
        printf("done\n");
#else
        if (first_time) {
            if ((ne = new_ivector(2 * (SIZE + 1))) == NULL) {
                fprintf(stderr, "etalu:neѤΥ꡼­ޤ\n");
                exit(1);
            }
            if ((ip = new_ivector(SIZE + 1)) == NULL) {
                fprintf(stderr, "etalu:ipѤΥ꡼­ޤ\n");
                exit(1);
            }
            if ((ie = new_ivector(L2)) == NULL) {
                fprintf(stderr, "etalu: ٥ȥ ie ѤΥ꡼­ޤ\n");
                exit(1);
            }
            if ((e = new_vector(L2)) == NULL) {
                fprintf(stderr, "etalu: ٥ȥ e ѤΥ꡼­ޤ\n");
                exit(1);
            }
            printf(" LU..."); fflush(stdout);
            LU(SIZE, o, e, ie, ne, ip);
            printf("done\n");
            first_time = 0;
        }
        printf(" solve_LU..."); fflush(stdout);
        solve_LU(SIZE, e, ie, ne, ip, u);
        printf("done\n");
#endif

        /* եɲ¸ */
        if (i % skip == 0) {
        printf(" writing data...");
        fflush(stdout);
        if ((f3 = fopen(argv[3], "a")) == NULL) {
            printf("Can't open %s", argv[3]);
            exit(2);
        }
        for (j = 0; j < SIZE; j++) {
            fprintf(f3, "%f\n", u[j]);
        }
        fclose(f3);
        printf("done\n");
        }
    }

    printf("done\n");
    return 0;
}

double menseki(x0, x1, x2, y0, y1, y2)
double x0, x1, x2, y0, y1, y2;
{
    return 0.5 * ((x1 - x0) * (y2 - y0) - (y1 - y0) * (x2 - x0));
}

matrix matprod1(a, b, l, m, n, c)
matrix a, b, c;
int l, m, n;
{
    double s;
    int i, j, k;

    for (i = 0; i < l; i++) {
        for (j = 0; j < n; j++) {
            s = 0.0;
            for (k = 0; k < m; k++) {
                s = s + a[i][k] * b[k][j];
            }
            c[i][j] = s;
        }
    }
}

matrix matprod2(a, b, c, k, l, m, n, d)
matrix a, b, c, d;
int k, l, m, n;
{
    matrix p = new_matrix2(k, m);

    matprod1(a, b, k, l, m, p);
    matprod1(p, c, k, m, n, d);

    free_matrix(p);
}

make(T, SIZE, o, u, nu, rho, tau, tht, x, y, num, cum, fx, fy, sx, sy,
     exforcx, exforcy, moo, mxx, myy, hx, hy)
int T, SIZE, **num, *cum;
double nu, rho, tau, tht;
vector u, x, y, fx, fy, sx, sy, exforcx, exforcy;
matrix o, moo, mxx, myy, hx, hy;
{
    int i, j, k;
    double b1, b2, b3, c1, c2, c3, l1, l2, l3, s, t, nurho;

    matrix a = new_matrix2(6, 6);
    matrix ta = new_matrix2(6, 6);
    matrix b = new_matrix2(6, 6);
    matrix c = new_matrix2(6, 6);
    matrix d = new_matrix2(6, 1);
    matrix d1 = new_matrix2(6, 1);
    matrix g = new_matrix2(3, 3);
    matrix z = new_matrix2(6, 6);
    matrix r = new_matrix2(6, 1);

    nurho = nu * rho;

    a[0][0] = 1.0;
    a[0][4] = -1.0;
    a[0][5] = -1.0;
    a[1][1] = 1.0;
    a[1][3] = -1.0;
    a[1][5] = -1.0;
    a[2][2] = 1.0;
    a[2][3] = -1.0;
    a[2][4] = -1.0;
    a[3][3] = 4.0;
    a[4][4] = 4.0;
    a[5][5] = 4.0;

    ta[0][0] = 1.0;
    ta[1][1] = 1.0;
    ta[2][2] = 1.0;
    ta[3][1] = -1.0;
    ta[3][2] = -1.0;
    ta[3][3] = 4.0;
    ta[4][0] = -1.0;
    ta[4][2] = -1.0;
    ta[4][4] = 4.0;
    ta[5][0] = -1.0;
    ta[5][1] = -1.0;
    ta[5][5] = 4.0;

    for (k = 0; k < T; k++) {

        s = menseki(x[num[k][0]], x[num[k][1]], x[num[k][2]],
                    y[num[k][0]], y[num[k][1]], y[num[k][2]]);


        if (s < 0.0) {
            printf(" %d ǤѤˤʤäƤޤ\n", k);
            exit(0);
        }
        t = 0.5 / s;

        b1 = t * (y[num[k][1]] - y[num[k][2]]);
        b2 = t * (y[num[k][2]] - y[num[k][0]]);
        b3 = t * (y[num[k][0]] - y[num[k][1]]);

        c1 = t * (x[num[k][2]] - x[num[k][1]]);
        c2 = t * (x[num[k][0]] - x[num[k][2]]);
        c3 = t * (x[num[k][1]] - x[num[k][0]]);

        l1 = hypot(x[num[k][2]] - x[num[k][1]], y[num[k][1]] - y[num[k][2]]);
        l2 = hypot(x[num[k][2]] - x[num[k][0]], y[num[k][0]] - y[num[k][2]]);
        l3 = hypot(x[num[k][0]] - x[num[k][1]], y[num[k][1]] - y[num[k][0]]);


        b[0][0] = 2 * b1;
        b[0][4] = b3;
        b[0][5] = b2;
        b[1][1] = 2 * b2;
        b[1][3] = b3;
        b[1][5] = b1;
        b[2][2] = 2 * b3;
        b[2][3] = b2;
        b[2][4] = b1;
        b[3][1] = b3;
        b[3][2] = b2;
        b[4][0] = b3;
        b[4][2] = b1;
        b[5][0] = b2;
        b[5][1] = b1;

        c[0][0] = 2 * c1;
        c[0][4] = c3;
        c[0][5] = c2;
        c[1][1] = 2 * c2;
        c[1][3] = c3;
        c[1][5] = c1;
        c[2][2] = 2 * c3;
        c[2][3] = c2;
        c[2][4] = c1;
        c[3][1] = c3;
        c[3][2] = c2;
        c[4][0] = c3;
        c[4][2] = c1;
        c[5][0] = c2;
        c[5][1] = c1;


        for (i = 0; i < 3; i++) {
            for (j = 0; j < 3; j++) {
                if (i != j)
                    g[i][j] = s / 12;
                else
                    g[i][j] = s / 6;
            }
        }

        for (i = 0; i < 3; i++) {
            z[i][i] = s / 15;
            z[i + 3][i + 3] = s / 90;
        }
        z[0][1] = z[0][2] = s / 90;
        z[0][3] = s / 180;
        z[0][4] = z[0][5] = s / 120;
        z[1][2] = s / 90;
        z[1][3] = s / 120;
        z[1][4] = s / 180;
        z[1][5] = s / 120;
        z[2][3] = z[2][4] = s / 120;
        z[2][5] = s / 180;
        z[3][4] = z[3][5] = s / 180;
        z[4][5] = s / 180;

        z[1][0] = s / 90;
        z[2][0] = z[2][1] = s / 90;
        z[3][0] = s / 180;
        z[3][1] = z[3][2] = s / 120;
        z[4][0] = s / 120;
        z[4][1] = s / 180;
        z[4][2] = s / 120;
        z[4][3] = s / 180;
        z[5][0] = z[5][1] = s / 120;
        z[5][2] = z[5][3] = z[5][4] = s / 180;

        for (i = 0; i < 3; i++) {
            d[i][0] = s / 6;
            d[i + 3][0] = s / 12;
        }
        matprod1(a, d, 6, 6, 1, r);

        d[0][0] = (l2 + l3) / 3;
        d[1][0] = (l3 + l1) / 3;
        d[2][0] = (l1 + l2) / 3;
        d[3][0] = l1 / 6;
        d[4][0] = l2 / 6;
        d[5][0] = l3 / 6;
        matprod1(a, d, 6, 6, 1, d1);


        matprod2(a, b, g, 6, 6, 3, 3, hx);
        matprod2(a, c, g, 6, 6, 3, 3, hy);
        matprod2(hx, b, ta, 6, 3, 6, 6, mxx);
        matprod2(hy, c, ta, 6, 3, 6, 6, myy);
        matprod2(ta, z, a, 6, 6, 6, 6, moo);


        for (i = 0; i < 6; i++) {
            for (j = 0; j < 6; j++) {
                o[cum[num[k][i]]][cum[num[k][j]]] += rho * moo[i][j] 
                      + tau * (1.0 - tht) * nurho * (mxx[i][j] + myy[i][j]);

                o[cum[num[k][i]] + 1][cum[num[k][j]] + 1] += rho * moo[i][j] 
                      + tau * (1.0 - tht) * nurho * (mxx[i][j] + myy[i][j]);
            }
            for (j = 0; j < 3; j++) {
                o[cum[num[k][i]]][cum[num[k][j]] + 2] -= tau * (1.0 - tht) * hx[i][j];
                o[cum[num[k][j]] + 2][cum[num[k][i]]] -= hx[i][j];
                o[cum[num[k][i]] + 1][cum[num[k][j]] + 2] -= tau * (1.0 - tht) * hy[i][j];
                o[cum[num[k][j]] + 2][cum[num[k][i]] + 1] -= hy[i][j];
            }

            exforcx[cum[num[k][i]]] = rho * r[i][0] * fx[num[k][i]] 
                                         + d1[i][0] * sx[num[k][i]];
            exforcx[cum[num[k][i]] + 1] = rho * r[i][0] * fy[num[k][i]] 
                                         + d1[i][0] * sy[num[k][i]];


        }
    }
    free_matrix(a);
    free_matrix(ta);
    free_matrix(b);
    free_matrix(c);
    free_matrix(d);
    free_matrix(r);
    free_matrix(g);
/*  free_matrix(hx);  free_matrix(hy);
   free_matrix(mxx);
   free_matrix(myy);
 */
}


/* դκ */
umake(T, o, u, moo, mxx, myy, hx, hy, new_u, exforcx, exforcy, 
                              num, cum, nu, rho, tau, tht, SIZE)
int T, SIZE, *cum, **num;
double nu, rho, tau, tht;
vector u, new_u, exforcx, exforcy;
matrix o, moo, mxx, myy, hx, hy;
{
    int i, j, k;
    for (k = 0; k < T; k++) {
        for (i = 0; i < 6; i++) {
            for (j = 0; j < 6; j++) {
                /* matrix for uhenn  make */
                new_u[cum[num[k][i]]] += u[cum[num[k][j]]] * (rho * moo[i][j] 
                                       - tau * tht * nu * rho * (mxx[i][j] + myy[i][j]));
                new_u[cum[num[k][i]] + 1] += u[cum[num[k][j]] + 1] * (rho * moo[i][j] 
                                       - tau * tht * nu * rho * (mxx[i][j] + myy[i][j]));
            }

            for (j = 0; j < 3; j++) {
                new_u[cum[num[k][j]]] += u[cum[num[k][j]] + 2] * tau * tht * hx[i][j];
                new_u[cum[num[k][j]] + 1] += u[cum[num[k][j]] + 2] * tau * tht * hy[i][j];
                new_u[cum[num[k][j]] + 2] = 0.0;

            }

            /* external force at u */
            new_u[cum[num[k][i]]] += exforcx[cum[num[k][i]]];
            /* external force at v */
            new_u[cum[num[k][i]] + 1] += exforcx[cum[num[k][i]] + 1];
        }
    }

    for (i = 0; i < SIZE; i++) {
        u[i] = 0.0;
        u[i] = new_u[i];
    }
    for (i = 0; i < SIZE; i++)
        new_u[i] = 0.0;
/* free(new_u); */
}

change(o, k, SIZE)
int k, SIZE;
matrix o;
{
    int i;

    for (i = 0; i < SIZE; i++) {
        o[k][i] = 0.0;
    }
    o[k][k] = 1.0;
}

bound(o, u, b, bx, by, N, D, cum, SIZE)
int b[], N, D, cum[], SIZE;
vector u, bx, by;
matrix o;
{
    int i, j;

    for (i = 0; i < D; i++) {
        j = cum[b[i]];
        change(o, j, SIZE);
        change(o, j + 1, SIZE);
        u[j] = bx[i];
        u[j + 1] = by[i];
    }
    if (N == 0) {
        change(o, 2, SIZE);
        u[2] = 0.0;
    }
}

etalu(o, u, SIZE)
int SIZE;
vector u;
matrix o;
{
    int i, j, k, jk, irow, length_a;
    int num, is, ier;
    ivector ia, ie, nwk, ne, ip;
    double val, work, piv, eps = 1.0e-14;
    vector a, e;
    vector x, we;
    /* e, ie, ne, ip */

    printf("number of unknowns=%d\n", SIZE);
    if ((nwk = new_ivector(SIZE + 1)) == NULL) {
        fprintf(stderr, "etalu:nwkѤΥ꡼­ޤ\n");
        exit(1);
    }
    if ((ne = new_ivector(2 * (SIZE + 1))) == NULL) {
        fprintf(stderr, "etalu:neѤΥ꡼­ޤ\n");
        exit(1);
    }
    if ((ip = new_ivector(SIZE + 1)) == NULL) {
        fprintf(stderr, "etalu:ipѤΥ꡼­ޤ\n");
        exit(1);
    }
    if ((ie = (int *) malloc(sizeof(int) * L2)) == NULL) {
        fprintf(stderr, "etalu: ٥ȥ ie ѤΥ꡼­ޤ\n");
    }
    if ((e = new_vector(L2)) == NULL) {
        fprintf(stderr, "etalu: ٥ȥ e ѤΥ꡼­ޤ\n");
    }
    x = new_vector(SIZE + 1);
    we = new_vector(SIZE + 1);

    /* prepare A */
    length_a = 0;
    for (i = 0; i < SIZE; i++)
        for (j = 0; j < SIZE; j++)
            if (o[j][i] != 0.0)
                length_a++;
    length_a++;
    if ((ia = new_ivector(length_a)) == NULL) {
        fprintf(stderr, "etalu: ٥ȥ ia ѤΥ꡼­ޤ\n");
        exit(1);
    }
    if ((a = new_vector(L)) == NULL) {
        fprintf(stderr, "etalu: ٥ȥ a ѤΥ꡼­ޤ\n");
        exit(1);
    }
    k = 1;
    nwk[0] = 0;
    for (i = 0; i < SIZE; i++) {
        for (j = 0; j < SIZE; j++) {
            if (o[j][i] != 0.0) {
                a[k] = o[j][i];
                ia[k] = j + 1;
                k++;
            }
        }
        nwk[i + 1] = k - 1;
    }

    if (L <= SIZE) {
        printf("INVALID ARGUMENT. %d %d \n", L, SIZE);
        ier = 2;
        return 0;
    }
    ier = is = ne[0] = ne[1] = num = 0;

    for (i = 1; i <= SIZE; i++)
        ip[i] = 0;
    for (k = 1; k <= SIZE; k++) {
        for (i = 1; i <= SIZE; i++)
            we[i] = 0.0;
        for (i = nwk[k - 1] + 1; i <= nwk[k]; i++)
            we[ia[i]] = a[i];
        if (k != 1) {
            jk = k - 1;
            updtel(e, ie, ne, we, ip, jk);
/* COMPUTATION OF ETA */
        }
/* SELECTION OF PIVOT */
        irow = 0;
        val = 0.0;
        for (i = k; i <= SIZE; i++) {
            work = fabs(we[i]);
            if (work > val) {
                val = work;
                irow = i;
            }
        }
        if (val <= eps) {
            printf("STOP WITH ZERO PIVOT %d \n", k);
            ier = 1;
            return 0;
        }
        ip[k] = irow;
        if (irow != k) {
            work = we[k];
            we[k] = we[irow];
            we[irow] = work;
        }
/* WRITE(*,*) (WE[i],I=1,M) */
/* GENERATION OF ETA */
        piv = -1.0 / we[k];
        we[k] = -1.0;
        for (i = k; i <= SIZE; i++) {
            we[i] *= piv;
            if (fabs(we[i]) >= eps) {
                num++;
                e[num] = we[i];
                ie[num] = i;
            }
        }
        ne[2 * k] = num;
        if (k == 1) {
            ne[3] = ne[2];
        } else {
            for (i = 1; i < k; i++) {
                if (fabs(we[i]) >= eps) {
                    num++;
                    e[num] = -we[i];
                    ie[num] = i;
                }
            }
            ne[2 * k + 1] = num;
        }
    }
/* COMPUTION OF X */
    for (i = 0; i < SIZE; i++)
        x[i + 1] = u[i];
    updtel(e, ie, ne, x, ip, SIZE);
    updteu(e, ie, ne, x, SIZE);
    for (k = 0; k < SIZE; k++)
        u[k] = x[k + 1];

    free(ia);
    free(ie);
    free(nwk);
    free(ne);
    free(ip);
    free(a);
    free(e);
    free_vector(x);
    free_vector(we);
}

LU(SIZE, o, e, ie, ne, ip)
int SIZE;
matrix o;
vector e;
ivector ie, ne, ip;
{
    int i, j, k, jk, irow, length_a;
    int num, is, ier;
    double val, work, piv, eps = 1.0e-14;
    ivector ia, nwk;
    vector a, we;
    /* e, ie, ne, ip */

    if ((nwk = new_ivector(SIZE + 1)) == NULL) {
        fprintf(stderr, "LU: nwkѤΥ꡼­ޤ\n");
        exit(1);
    }
    if ((we = new_vector(SIZE + 1)) == NULL) {
        fprintf(stderr, "LU: weѤΥ꡼­ޤ\n");
        exit(1);
    }
    /* prepare A */
    length_a = 0;
    for (i = 0; i < SIZE; i++)
        for (j = 0; j < SIZE; j++)
            if (o[j][i] != 0.0)
                length_a++;
    length_a++;
    if ((ia = new_ivector(length_a)) == NULL) {
        fprintf(stderr, "LU: ٥ȥ ia ѤΥ꡼­ޤ\n");
        exit(1);
    }
    if ((a = new_vector(length_a)) == NULL) {
        fprintf(stderr, "LU: ٥ȥ a ѤΥ꡼­ޤ\n");
        exit(1);
    }
    k = 1;
    nwk[0] = 0;
    for (i = 0; i < SIZE; i++) {
        for (j = 0; j < SIZE; j++) {
            if (o[j][i] != 0.0) {
                a[k] = o[j][i];
                ia[k] = j + 1;
                k++;
            }
        }
        nwk[i + 1] = k - 1;
    }

    if (L <= SIZE) {
        printf("INVALID ARGUMENT. %d %d \n", L, SIZE);
        ier = 2;
        return 0;
    }
    ier = is = ne[0] = ne[1] = num = 0;

    for (i = 1; i <= SIZE; i++)
        ip[i] = 0;
    for (k = 1; k <= SIZE; k++) {
        for (i = 1; i <= SIZE; i++)
            we[i] = 0.0;
        for (i = nwk[k - 1] + 1; i <= nwk[k]; i++)
            we[ia[i]] = a[i];
        if (k != 1) {
            jk = k - 1;
            updtel(e, ie, ne, we, ip, jk);
/* COMPUTATION OF ETA */
        }
/* SELECTION OF PIVOT */
        irow = 0;
        val = 0.0;
        for (i = k; i <= SIZE; i++) {
            work = fabs(we[i]);
            if (work > val) {
                val = work;
                irow = i;
            }
        }
        if (val <= eps) {
            printf("STOP WITH ZERO PIVOT %d \n", k);
            ier = 1;
            return 0;
        }
        ip[k] = irow;
        if (irow != k) {
            work = we[k];
            we[k] = we[irow];
            we[irow] = work;
        }
/* WRITE(*,*) (WE[i],I=1,M) */
/* GENERATION OF ETA */
        piv = -1.0 / we[k];
        we[k] = -1.0;
        for (i = k; i <= SIZE; i++) {
            we[i] *= piv;
            if (fabs(we[i]) >= eps) {
                num++;
                e[num] = we[i];
                ie[num] = i;
            }
        }
        ne[2 * k] = num;
        if (k == 1) {
            ne[3] = ne[2];
        } else {
            for (i = 1; i < k; i++) {
                if (fabs(we[i]) >= eps) {
                    num++;
                    e[num] = -we[i];
                    ie[num] = i;
                }
            }
            ne[2 * k + 1] = num;
        }
    }

    free_ivector(ia);
    free_ivector(nwk);
    free_vector(a);
    free_vector(we);
}

solve_LU(SIZE, e, ie, ne, ip, u)
int SIZE;
vector e, u;
ivector ie, ne, ip;
{
    int i;
    vector x;
    if ((x = new_vector(SIZE + 1)) == NULL) {
        fprintf(stderr, "solve_LU: new_vector error\n");
        exit(1);
    }
    for (i = 0; i < SIZE; i++)
        x[i + 1] = u[i];
    updtel(e, ie, ne, x, ip, SIZE);
    updteu(e, ie, ne, x, SIZE);
    for (i = 0; i < SIZE; i++)
        u[i] = x[i + 1];
    free_vector(x);
}

updtel(e, ie, ne, we, ip, K)
int K;
ivector ie, ne, ip;
vector e, we;
{
    int i, j, irow;
    double work;

    for (j = 1; j <= K; j++) {
        irow = ip[j];
        if (irow != j) {
            work = we[j];
            we[j] = we[irow];
            we[irow] = work;
        }
        work = we[j];
        we[j] = 0.0;
        for (i = ne[2 * j - 1] + 1; i <= ne[2 * j]; i++) {
            we[ie[i]] += e[i] * work;
        }
    }
}

updteu(e, ie, ne, we, SIZE)
ivector ie, ne;
vector e, we;
{
    int i, j;
    double work;

    for (j = SIZE; j >= 2; j--) {
        if (ne[2 * j] != ne[2 * j + 1]) {
            work = we[j];
            for (i = ne[2 * j] + 1; i <= ne[2 * j + 1]; i++) {
                we[ie[i]] += e[i] * work;
            }
        }
    }
}

cavity(M, U, T, num, cum)
int M, U, T, **num, *cum;
{
    int Q, k, j;
    Q = 2 * U;                  /* vector of p */
    for (k = 0; k < 2 * M; k += 2) {
        for (j = 0; j < 2; j++) {
            cum[num[k][j]] = Q;
            Q += 1;
        }
    }
    for (k = 0; k < T; k += 2) {
        cum[num[k][3]] = Q;
        Q += 1;
    }
    cum[num[T - 1][3]] = Q;
}
